package de.akquinet.smsfeedback;

import org.easymock.EasyMock

class AnimatedConsoleTest extends GroovyTestCase {

	def control = EasyMock.createControl()
	def random = control.createMock(BooleanRandom.class)
	def out = new ByteArrayOutputStream()
	def console = new AnimatedConsole(delay: 0, random: random, out: new PrintStream(out))
	
	void testWithoutBackspaces() {
		EasyMock.expect(random.boolean).andReturn(false).times(4)
		control.replay()
		console.print("test")
		assertEquals "test", out.toString()
		control.verify()
	}

	void testWithBackspaces() {
		[false, true, false, true].each { 
			EasyMock.expect(random.boolean).andReturn(it)
		}
		control.replay()
		console.print("test")
		assertEquals "te\u0008 \u0008est\u0008 \u0008t", out.toString()
		control.verify()
	}

}
