package de.akquinet.smsfeedback;

import org.easymock.EasyMock

class SmsReaderTest extends GroovyTestCase {

	def control = EasyMock.createControl()
	def database = control.createMock(SmsDatabase.class)
	def display = control.createMock(SmsDisplay.class)
	def reader = new SmsReader(display:display, database:database)  
	
	def smsList = [new Sms(phone:"1",message:"m1"),
	               new Sms(phone:"2",message:"m2")]
	
	void testDoesntDisplayEmptyList() {
		EasyMock.expect(database.readSms()).andReturn([])
		control.replay()
		reader.showSms()
		control.verify()
	}
	
	void testReadsMessages() {
		EasyMock.expect(database.readSms()).andReturn(smsList)
		EasyMock.expect(display.display(smsList[0]))
		EasyMock.expect(display.display(smsList[1]))
		control.replay()
		reader.showSms()
		control.verify()
	}
	
	void testReadsOnlyNewMessages() {
		EasyMock.expect(database.readSms()).andReturn(smsList[0..0])
		EasyMock.expect(database.readSms()).andReturn(smsList)
		EasyMock.expect(display.display(smsList[0]))
		EasyMock.expect(display.display(smsList[1]))
		control.replay()
		2.times{ reader.showSms() }
		control.verify()		
	}
}
